require "luas.shortcuts"

BoundingBox = Object:extend()

function BoundingBox:new(boxImg)
--function BoundingBox:new(mnX, mnY, mxX, mxY)

	
	local imgdat = boxImg:getData()
	local minFound = false
	local maxFound = false
	self.minX = 0
	self.minY = 0
	self.maxX = 0
	self.maxY = 0
	
	--debug
	--f = love.filesystem.newFile("boundingBoxData.txt")
	--f:open("w")


	
	--should work instead
	for j = 1,imgdat:getWidth(), 1 do
		for k = 1,imgdat:getHeight(), 1 do
			
			local r, g, b, a =  imgdat:getPixel(j-1, k-1)
			--if r==0 and g==0 and b==1 then --erkennt hot pink als schwarz, andere Farben aber nicht
			
			--debug
			--print("pixel x" .. j-1 .. " y" .. k-1 .. "")
			--print("Red:    " .. r .. "")
			--print("Green:  " .. g .. "")
			--print("Blue:   " .. b .. "")
			--print("Yellow: " .. a .. "")
			--f:write("pixel x" .. j-1 .. " y" .. k-1 .. "\r\n")
			--f:write("Red:   " .. r .. "\r\n")
			--f:write("Green: " .. g .. "\r\n")
			--f:write("Blue:  " .. b .. "\r\n")
			--f:write("Yellow:" .. a .. "\r\n")
			
			
			if r==0 and g==0 and b==1 then
				if minFound == false then
					self.minX = j
					self.minY = k
					minFound  = true
				elseif maxFound == false then
					self.maxX = j
					self.maxY = k
					maxFound = true
				end
			end
		end
	end
	--debug
	--f:close()
	
	
	--self.minX = mnX
	--self.minY = mnY
	--self.maxX = mxX
	--self.maxY = mxY
	
	--boundingbox transformed with objectposition, must be updated steadily
	self.minXT = self.minX
	self.minYT = self.minY
	self.maxXT = self.maxX
	self.maxYT = self.maxY
	
	
end


function BoundingBox.doUpdate(self, xIn, yIn)

	self.minXT = self.minX + xIn
	self.minYT = self.minY + yIn
	
	self.maxXT = self.maxX + xIn
	self.maxYT = self.maxY + yIn
end

function BoundingBox.draw(self)

	local dx = self.maxXT - self.minXT
	local dy = self.maxYT - self.minYT
	love.graphics.rectangle("line", self.minXT, self.minYT, dx , dy)
end

function BoundingBox:CollisionTest(oBox)

	local bCollide=false

	if self.minXT < oBox.maxXT then
		if self.maxXT > oBox.minXT then
			if self.minYT < oBox.maxYT then
				if self.maxYT > oBox.minYT then
					bCollide = true
				end
			end
		end
	end
	
	return bCollide
end


function BoundingBox.InBoxTest(self,aPtX, aPtY)
	
	local bInBox = false
	
	--print("check inside boundingbox")
	--print("PtX "..aPtX)
	--print("PtY "..aPtX)
	--print("self minxt ".. self.minXT)
	
	if self.minXT <= aPtX then
		if aPtX <= self.maxXT then
			if self.minYT <= aPtY then
				if aPtY <= self.maxYT then
					bInBox = true
				end
			end
		end
	end
	
	return bInBox
end

function BoundingBox.HitGroundTest(self, aGroundLv)

	if self.maxYT >= aGroundLv then
		return true
	else
		return false
	end
end

--function BoundingBox.checkOnSolids()
--	local collisionResult = false

	--TODO may need better solution, for now check boundingbox Border on Obstacles
--	for i = self.minXT, 1, self.maxXT do
--		for i = self.minYT, 1, self.maxYT do
			
--			local bkgdat  = tblScrollSpan[lvMainLevel][lvSubLevel]:getData()
--			local bkgdat2 =tblScrollSpan[nextLevelMainLevel][nextLevelSubLevel]:getData()
			
--		end
--	end

--	return collisionResult
--end



