require "luas.shortcuts"
require "luas.extendedLoader"
require "luas.boundingBox"

Core = Object:extend()


function Core.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset() --lots of other values initialized here and also reset to defaults on deactivation

end


function Core:reset()

	self.active = false	
	
	self.hitPoints = 1 --basic before activation
	
	self.takenHits = 0 --taken hit since last update? insert number hitpoints to be taken

	self.scoreReward = 0                    --see defineColorType
	
	self.enmWidth  = 0 
	self.enmHeight = 0 
	
	self.currentGph  = nil
	--self.currentBBox = nil --doesnt have one
	
	self.x = 0
	self.y = 0
	
end

function Core.putPosition(self, aPx, aPy)

	self.x = aPx
	self.y = aPy
	
	--self.adjustBoundingBox(self)
end

function Core.activate(self)
	
	self.active = true
	
	self.currentGph = enmCoreGph
	
	--self.currentBBox =
	
	self.scoreReward = 300
	
	self.enmWidth  = 15
	self.enmHeight = 9
	
	self.hitPoints = 1
	
end

function Core.plantExplosion(self)

	--no explosion here
	
end

function Core.takeHit(self, aDmg)

	self.takenHits = self.takenHits + aDmg --adding up damage from multiple bullets in 1 update possible
end

function Core.deactivate(self)

	--self.active = false --is not enough, will cause carry-over of behaviors such as matrix/roaming mode
	
	--clean it up on deactivation
	self:reset()
end

function Core.doUpdate(self)


	if self.active == true then
	
		if self.takenHits > 0 then --flag set by gamemode, need to take hp and check for death
			self.hitPoints = self.hitPoints - self.takenHits
			
			self.takenHits = 0 --otherwise will take more hitpoints in next update
		
			if self.hitPoints <= 0 then
				self.plantExplosion(self)
				
				globAddScore(self.scoreReward)
				--bugfix: add score BEFORE deactivation
				
				--print("Enemy dies")
					
				if globIsInDemoMode == false then 
					enemyDie4Snd:stop()
					enemyDie4Snd:play()
				end
				
				self.deactivate(self)
			end
		end
	end
end

function Core.draw(self)

	if self.active then	
		
		lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
	end
end

--function Core.adjustBoundingBox(self)
--
--	--1 frame, 1 box, simplified version
--	self.currentBBox.doUpdate(self.currentBBox, self.x, self.y)
--end







