require "luas/shortcuts"
require "luas/boundingBox"
require "luas/extendedLoader"

--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

EnemyA = Object:extend()


function EnemyA.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset() --lots of other values initialized here and also reset to defaults on deactivation

end


function EnemyA:reset()

	self.active = false	
	
	self.hitPoints = 1 --basic before activation
	
	self.takenHits = 0 --taken hit since last update? insert number hitpoints to be taken

	self.scoreReward = 0                    --see defineColorType
	
	self.enmWidth  = 0
	self.enmHeight = 0
	
	self.boundsLeft  = 0
	self.boundsRight = 190
	self.boundsTop   = 0
	self.boundsBtm   = 70
	
	self.x = 0
	self.y = 0
	
	self.startPosX = 0
	self.startPosY = 0
	
	self.line = 0
	self.reverseFlag = false
	
	self.anmStep = 0 --ineffective value
	self.anmProgress = 0
	self.anmThresh = 5
	self.anmIndex = 0 --invalid value
	self.anmIndexMax = 2
	
	self.plantShotFlag = false
	
	
end

function EnemyA.putStartPosition(self, aPx, aPy)
	self.x = aPx
	self.y = aPy
	
	self.startPosX = aPx --for matrix-type movement and repeatedly recalculating self.x 
	self.startPosY = aPy
	
	--adjustBoundingBox on first placement
	--self.adjustBoundingBox(self) --no boundingBox
end

function EnemyA.lineFromCoordinate(self)
	if self.y == 0 then
		self.line = 1
		self.reverseFlag = false
	elseif self.y == 10 then
		self.line = 2
	elseif self.y == 20 then
		self.line = 3
	elseif self.y == 30 then
		self.line = 4
	elseif self.y == 40 then
		self.line = 5
	elseif self.y == 50 then
		self.line = 6
	elseif self.y == 60 then
		self.line = 7
	elseif self.y == 70 then
		self.line = 8
		self.reverseFlag = true
	end
end


function EnemyA.activate(self,aPutOnMatrix, aLvNum) --let bot know speed ect by level
									--aBasicSpeedComp, aRandomSpeedComp, aPutOnMatrix)

	--active
	self.active = true	
	
	self.hitPoints = 1
	
	self.scoreReward = 30
	
	self.lineFromCoordinate(self) --set line
	
	self.anmStep = 1 --effective value
	self.anmIndex = love.math.random(2) --valid value
	
	self.currentGph = enemyAGph[self.anmIndex]
	--self.currentBBox = BoundingBox(enemyABoxGph) --no bounding box
	
	self.enmWidth  = 10
	self.enmHeight = 10
	
end

function EnemyA.plantExplosion(self)

	globExplosionA[globExplosionAIndex].activate(globExplosionA[globExplosionAIndex], self.x - 2, self.y - 2)
	globExplosionAIndex = globExplosionAIndex + 1
	if globExplosionAIndex > globExplosionAMax then
		globExplosionAIndex = 1
	end
end


function EnemyA.takeHit(self, aDmg)

	self.takenHits = self.takenHits + aDmg --adding up damage from multiple bullets in 1 update possible
end

function EnemyA.deactivate(self)

	--self.active = false --is not enough, will cause carry-over of behaviors such as matrix/roaming mode
	
	--clean it up on deactivation
	self:reset()
end

function EnemyA.doUpdate(self)


	if self.active == true then
	
	
		if self.takenHits > 0 then --flag set by gamemode, need to take hp and check for death
			self.hitPoints = self.hitPoints - self.takenHits
			
			self.takenHits = 0 --otherwise will take more hitpoints in next update
		
			if self.hitPoints <= 0 then
				self.plantExplosion(self)
				
				--give score
				--globScore = globScore + self.scoreReward
				--
				--nope: increasing score must do more than that
				--Therefore
				globAddScore(self.scoreReward)
				--bugfix: add score BEFORE deactivation
				
				if globIsInDemoMode == false then 
					enemyDie1Snd:stop()
					enemyDie1Snd:play()
				end
				
				self.deactivate(self)
				
			end
		end
	end
	
	
	if self.active == true then
	
		self.doAnimation(self)
		self.doMovement(self)
		
		if self.plantShotFlag == true then
			self.plantShot(self)
			self.plantShotFlag = false --flamethrower effect when line is left out :-)
		end
		
	end

end

function EnemyA.doAnimation(self)

	self.anmProgress = self.anmProgress + self.anmStep
	
	if self.anmProgress >= self.anmThresh then
		self.anmProgress = 0
		
		self.anmIndex = self.anmIndex + 1
		
		if self.anmIndex > self.anmIndexMax then
			self.anmIndex = 1
		end
		
		self.currentGph = enemyAGph[self.anmIndex]
		
	end

end

function EnemyA.doMovement(self)

	if self.line == 1 or self.line == 3 or self.line == 5 or self.line == 7 then
		self.x = self.x + 2
	else
		self.x = self.x - 2
	end
	
	if self.x > self.boundsRight then
		self.x = self.boundsRight
		
		if self.reverseFlag == false then
			self.y = self.y + 2
		else
			self.y = self.y - 2
		end
		
	end
	
	if self.x < self.boundsLeft then
		self.x = self.boundsLeft
		
		if self.reverseFlag == false then
			self.y = self.y + 2
		else
			self.y = self.y - 2
		end
		
	end
	
	self.lineFromCoordinate(self)

end

function EnemyA.plantShot(self)

	--if self.active == true then --active was tested outside in this method
	
		local lclLaunchPX = self.x + 1 + love.math.random(8) 
		local lclLaunchPY = self.y + 5
		
		local lclPosFactorY = 100 - self.y --make speed dependant on the hight of the enemy on the playfield
		lclPosFactorY = lclPosFactorY/100
		lclPosFactorY = lclPosFactorY*levlAEnmBulSpdPosFactorY

		globEnmBullets1[globEnmBullets1Index].activate(globEnmBullets1[globEnmBullets1Index], lclLaunchPX, lclLaunchPY, 0.0, (levlAEnmBulSpdBasicY + love.math.random()*levlAEnmBulSpdRndY + love.math.random()*lclPosFactorY) )
		
		globEnmBullets1Index = globEnmBullets1Index + 1
		if globEnmBullets1Index >= globEnmBullets1IndexMax then
			globEnmBullets1Index = 1
		end
		
		if globIsInDemoMode == false then 
			shotSnd:stop()
			shotSnd:play()
		end
	--end
	
end


function EnemyA.prepareShoot(self)
	print("Bot Prepare shooting")
	
	--keep info that shooting needs to occur separate from actual shooting.
	--do the shooting in next update
	self.plantShotFlag = true
	
end

function EnemyA.draw(self)

	if self.active then	
		--take graphics directly from extendedloader for this one
		lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
		
		--debug
		--self.currentBBox.draw(self.currentBBox)
	end
end



