require "luas.shortcuts"
require "luas.extendedLoader"

ENMBULLET_INACTIVE   = 0	--type could be completely different projectiles in 1 class (or do different classes)
ENMBULLET_ACTIVE     = 1	--for this simple example, just active/inactive


EnmBullet2 = Object:extend()


function EnmBullet2.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:resetType()
	
	--no bounding box
	--self.reservedBBox = BoundingBox(enmShotBoxGph)
	
	self.reservedGph = enmShotGph[2]

end


function EnmBullet2:resetType()

	self.type = ENMBULLET_INACTIVE
	--following will be determined by type that is given on activation
	self.width = 0
	self.height= 0
	--self.currentBBox       = nil --no boundingbox
	self.currentGph        = nil
	
	self.x = 0
	self.y = 0
	
	self.xSpeedStep     = 0.0
	self.xSpeedProgress = 0.0
	self.xSpeedThresh= threshold
	
	self.ySpeedStep     = 0.0
	self.ySpeedProgress = 0.0
	self.ySpeedThresh= threshold
	
	--boundaries (basic values, getting fine adjustment according to bulletsize below)
	self.boundsBtm   = 150 - 25 - 4 --screen height minus groundthickness minus shotheight

end

--may add bullet-type to parameterlist or do different classes for different bullets. 
--
function EnmBullet2.activate(self, aPX, aPY, aSX, aSY) --need loopdirection

	
	self.type = ENMBULLET_ACTIVE --SIMPLIFIED only one bullettype, activate
	
	--following will be determined by type that is given on activation
	self.width = 1 --for other shooters there could be variation between bullettype sizes, here it isn't
	self.height= 4
	
	--self.currentBBox = self.reservedBBox --no boundingbox
	self.currentGph  = self.reservedGph --to valid graphic
		
	--set bullet position
	self.x = aPX
	self.y = aPY
		
	--no boundingbox
	--self.adjustBoundingBox(self)
		
	--set bullet speeds
	self.xSpeedStep     = aSX
	self.ySpeedStep     = aSY
	
end


function EnmBullet2:deactivate()
	--set inactive, remove current-fields of boundingbox, sizes, graphics ect
	
	--set defaults
	self:resetType()
end

function EnmBullet2.doUpdate(self)

	
	if self.type ~= ENMBULLET_INACTIVE then --when bullet not inactive
		
		
		--##############################
		--# bullet movements
		--##############################
		
		--bullet movement in x-directions
		self.xSpeedProgress = self.xSpeedProgress + self.xSpeedStep
		while self.xSpeedProgress >= self.xSpeedThresh do --for positive x-Movement
			self.xSpeedProgress = self.xSpeedProgress - self.xSpeedThresh
			self.x = self.x + 1
		end
		while self.xSpeedProgress <= ((-1) * self.xSpeedThresh) do --for negative x-Movement
			self.xSpeedProgress = self.xSpeedProgress + self.xSpeedThresh
			self.x = self.x - 1
		end
		--bullet movements in y directions 
		self.ySpeedProgress = self.ySpeedProgress + self.ySpeedStep 
		
		while self.ySpeedProgress >= self.ySpeedThresh do --for positive y-Movement (not used in this game)
			self.ySpeedProgress = self.ySpeedProgress - self.ySpeedThresh
			self.y = self.y + 1
		end
		while self.ySpeedProgress <= ((-1) * self.ySpeedThresh) do --for negative y-Movement (standard case)
			self.ySpeedProgress = self.ySpeedProgress + self.ySpeedThresh
			self.y = self.y - 1
		end
		
		--##############################
		--# after movement adjust bounding box
		--##############################
		
		--self.adjustBoundingBox(self) --no boundingbox
		
		
		--##############################
		--# bullet deactivation on boundaries
		--##############################
		
		if self.y > self.boundsBtm then
			self:deactivate()
		end
		
		
	end
	
	--for collision-handling: see gamestates!

end

--function EnmBullet.adjustBoundingBox(self) --no boundingbox
--
--	--just in case include all boundingboxes (although bullet should not change during lifecycle)
--	--for i= 1,3,1 do
--		self.reservedBBox.doUpdate(self.reservedBBox, self.x, self.y)
--	--end
--end


function EnmBullet2.draw(self)
	if self.type ~= ENMBULLET_INACTIVE then
		lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
		
		--debug
		--self.currentBBox.draw(self.currentBBox)
	end
end




