require "luas.shortcuts"
require "luas.explosionParticle"


ExplosionB = Object:extend()


function ExplosionB.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset()

end

function ExplosionB:reset()

	self.active = false
	
	self.currentGph        = nil
	
	self.particleImages = {}

	self.particles = {}
	
	self.x = 0
	self.y = 0
	
	self.updateCounter = 0
end

function ExplosionB.activate(self, aGph, aPX, aPY)

	self.active = true

	self.currentGph = aGph
	
	self.x = aPX
	self.y = aPY

	
	for i = 1,19,1 do
			
		local locImageData = love.image.newImageData( 1, 7)
				
		locImageData:paste( self.currentGph:getData(), 0, 0, i-1, 0, 1, 7 )
				
		self.particleImages[i] = lg.newImage(locImageData)
				
	end
			
	local locIndex = 10
	local locSpeed = 0.0
	--first wave of particles move left
	while locIndex > 1 do
		locIndex = locIndex - 1
		locSpeed = locSpeed - 0.35
		self.particles[locIndex] = ExplosionParticle()
		self.particles[locIndex].activate(self.particles[locIndex], self.particleImages[locIndex], self.x + locIndex - 1, self.y, locSpeed, 0.0)
	end
	--second wave of particles move right
	locIndex = 10
	locSpeed = 0.0
	while locIndex < 19 do
		locIndex = locIndex + 1
		locSpeed = locSpeed + 0.35
		self.particles[locIndex] = ExplosionParticle()
		self.particles[locIndex].activate(self.particles[locIndex], self.particleImages[locIndex], self.x + locIndex - 1, self.y, locSpeed, 0.0)
	end
	--fill the gap in tne middle but dont activate the middle explosionparticle
	self.particles[10] = ExplosionParticle()
		
	
end

function ExplosionB:deactivate()

	self.reset(self)
end

function ExplosionB.doUpdate(self)

	if self.active == true then
		
		for i = 1,19,1 do
			self.particles[i].doUpdate(self.particles[i])
		end

		
		self.updateCounter = self.updateCounter + 1
		if self.updateCounter >= 20 then
			self.deactivate(self)
		end
	end

end

function ExplosionB.draw(self)

	if self.active == true then
		for i = 1,19,1 do
			self.particles[i].draw(self.particles[i])
		end
	end
end

