
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

ExplosionC = Object:extend()

function ExplosionC.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.colorIndex = 0
	self.pics = {}
	self.frames = {}
	
	self.anmStep       = 17 --use for index of frame (here set invalid)
	self.anmThresh     = 16

end

function ExplosionC.activate(self, aPX, aPY, aColor)

	self.colorIndex = aColor

	self.active = true

	self.x = aPX
	self.y = aPY
	
	
	--uses only the maincolor to color the explosion
	globEnmCMainColorIndex = self.colorIndex
	
	local locImageData = love.image.newImageData( 25, 21)
	locImageData:paste( enmExplodeCGph[1]:getData(), 0, 0, 0, 0, 25, 21 )
	self.pics[1] = lg.newImage(locImageData)
	self.pics[1]:setFilter("nearest","nearest")
	
	dat = self.pics[1]:getData()
	dat:mapPixel( makeReColor2 )
	self.pics[1]:refresh()
	
	local locImageData = love.image.newImageData( 25, 21)
	locImageData:paste( enmExplodeCGph[2]:getData(), 0, 0, 0, 0, 25, 21 )
	self.pics[2] = lg.newImage(locImageData)
	self.pics[2]:setFilter("nearest","nearest")
	
	dat = self.pics[2]:getData()
	dat:mapPixel( makeReColor2 )
	self.pics[2]:refresh()
	
	local locImageData = love.image.newImageData( 25, 21)
	locImageData:paste( enmExplodeCGph[3]:getData(), 0, 0, 0, 0, 25, 21 )
	self.pics[3] = lg.newImage(locImageData)
	self.pics[3]:setFilter("nearest","nearest")
	
	dat = self.pics[3]:getData()
	dat:mapPixel( makeReColor2 )
	self.pics[3]:refresh()
	
	local locImageData = love.image.newImageData( 25, 21)
	locImageData:paste( enmExplodeCGph[4]:getData(), 0, 0, 0, 0, 25, 21 )
	self.pics[4] = lg.newImage(locImageData)
	self.pics[4]:setFilter("nearest","nearest")
	
	dat = self.pics[4]:getData()
	dat:mapPixel( makeReColor2 )
	self.pics[4]:refresh()
	
	
	self.anmStep = 1
	
	self.frames[1] = self.pics[1]
	self.frames[2] = self.pics[1]
	self.frames[3] = self.pics[1]
	self.frames[4] = self.pics[1]
	self.frames[5] = self.pics[2]
	self.frames[6] = self.pics[2]
	self.frames[7] = self.pics[2]
	self.frames[8] = self.pics[2]
	self.frames[9] = self.pics[3]
	self.frames[10] = self.pics[3]
	self.frames[11] = self.pics[3]
	self.frames[12] = self.pics[3]
	self.frames[13] = self.pics[4]
	self.frames[14] = self.pics[4]
	self.frames[15] = self.pics[4]
	self.frames[16] = self.pics[4]


	
end

function ExplosionC.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function ExplosionC.doUpdate(self)

	if self.active then
		if self.anmStep <= self.anmThresh then
			self.anmStep = self.anmStep + 1
		end
	
		if self.anmStep > self.anmThresh then
			self.deactivate(self)
		end
	end
end

function ExplosionC.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmStep], self.x, self.y, 0, 1, 1)
	end
end


