require "luas.shortcuts"


ExplosionParticle = Object:extend()


function ExplosionParticle.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset()

end

function ExplosionParticle:reset()

	self.active = false

	self.currentGph        = nil
	
	self.x = 0
	self.y = 0
	
	self.xSpeedStep     = 0.0
	self.xSpeedProgress = 0.0
	self.xSpeedThresh= threshold
	
	self.ySpeedStep     = 0.0
	self.ySpeedProgress = 0.0
	self.ySpeedThresh= threshold
end

function ExplosionParticle.activate(self, aGph, aPX, aPY, aSX, aSY)

	self.active = true

	self.currentGph = aGph
	
	self.x = aPX
	self.y = aPY
	
	self.xSpeedStep     = aSX
	self.ySpeedStep     = aSY
end

function ExplosionParticle:deactivate()

	self.reset(self)
end

function ExplosionParticle.doUpdate(self)

	if self.active == true then
		
		self.xSpeedProgress = self.xSpeedProgress + self.xSpeedStep
		while self.xSpeedProgress >= self.xSpeedThresh do --for positive x-Movement
			self.xSpeedProgress = self.xSpeedProgress - self.xSpeedThresh
			self.x = self.x + 1
		end
		while self.xSpeedProgress <= ((-1) * self.xSpeedThresh) do --for negative x-Movement
			self.xSpeedProgress = self.xSpeedProgress + self.xSpeedThresh
			self.x = self.x - 1
		end
		--bullet movements in y directions (NOT USED IN THIS GAME)
		self.ySpeedProgress = self.ySpeedProgress + self.ySpeedStep 
		
		while self.ySpeedProgress >= self.ySpeedThresh do --for positive y-Movement (not used in this game)
			self.ySpeedProgress = self.ySpeedProgress - self.ySpeedThresh
			self.y = self.y + 1
		end
		while self.ySpeedProgress <= ((-1) * self.ySpeedThresh) do --for negative y-Movement (standard case)
			self.ySpeedProgress = self.ySpeedProgress + self.ySpeedThresh
			self.y = self.y - 1
		end
	end

end

function ExplosionParticle.draw(self)
	if self.active == true then
		lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
	end
end

