require "luas.helpers"
require "luas.shortcuts"
require "luas.shotSoundPool"
																										--Task AAG (part 2) load game graphics
function loadLevelContents()

	backGroundGph    = lg.newImage("gfx/Levels/Background.png")
	backGroundGph:setFilter("nearest","nearest")
	
	dat = backGroundGph:getData()
	dat:mapPixel( makeOpaquePink )
	backGroundGph:refresh()
	
	backGroundFlickerGph    = lg.newImage("gfx/Levels/BackgroundFlicker.png")
	backGroundFlickerGph:setFilter("nearest","nearest")
	
	dat = backGroundFlickerGph:getData()
	dat:mapPixel( makeOpaquePink )
	backGroundFlickerGph:refresh()
	
	foreGroundGph    = lg.newImage("gfx/Levels/Foreground.png")
	foreGroundGph:setFilter("nearest","nearest")
	
	dat = foreGroundGph:getData()
	dat:mapPixel( makeOpaquePink )
	foreGroundGph:refresh()
	
	foreGroundFlickerGph    = lg.newImage("gfx/Levels/ForegroundFlicker.png")
	foreGroundFlickerGph:setFilter("nearest","nearest")
	
	dat = foreGroundFlickerGph:getData()
	dat:mapPixel( makeOpaquePink )
	foreGroundFlickerGph:refresh()

end

function loadPlayerSprites()

	playerShipGph={}
	
	--for i=1,globMaxPlayers,1 do --can't access maxplayers from globals. globals are set up with extendedloader
	                              --not the other way round
	for i=1,1,1 do --only 1 player
		playerShipGph[i]    = lg.newImage("gfx/Ship/PlayerShip_"..i..".png")
		playerShipGph[i]:setFilter("nearest","nearest")
	
		dat = playerShipGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		playerShipGph[i]:refresh()
	
	end
	
	--boundingbox for collision
	shipBoxGph = lg.newImage("gfx/Ship/ShipBox.png")
	shipBoxGph:setFilter("nearest","nearest")
	
	--like a boundingbox for mouse movement
	mouseBoxGph = lg.newImage("gfx/Ship/MouseBox.png")
	mouseBoxGph:setFilter("nearest","nearest")
	
	playerShotGph = {}
	for i=1,1,1 do --only 1 player, hence only one playershot gph
		
		playerShotGph[i]    = lg.newImage("gfx/Ship/PlayerShot_"..i..".png")
		playerShotGph[i]:setFilter("nearest","nearest")
	
		dat = playerShotGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		playerShotGph[i]:refresh()
	end
	
	playerShotBoxGph = lg.newImage("gfx/Ship/PlayerShotBox.png")
	playerShotBoxGph:setFilter("nearest","nearest")
	
	
	playerExplodeGph ={}
	
	for i=1,1,1 do
	
		playerExplodeGph[i] = {}
		
		for j=1,8,1 do
	
			playerExplodeGph[i][j] = lg.newImage("gfx/Ship/PlayerExplode_"..i.."_"..j..".png")
			playerExplodeGph[i][j]:setFilter("nearest","nearest")
		
			dat = playerExplodeGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			playerExplodeGph[i][j]:refresh()
		end
	end

end

function loadEnemySprites()

	enemyAGph = {}
	
	for i = 1,2,1 do
		enemyAGph[i] = lg.newImage("gfx/Enemies/EnmA_"..i..".png")
		enemyAGph[i]:setFilter("nearest","nearest")
		
		dat = enemyAGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enemyAGph[i]:refresh()
	end 
	
	enemyBGph = {}
	
	for i = 1,2,1 do
	
		enemyBGph[i] = {}
		
		for j = 1,4,1 do
			enemyBGph[i][j] = lg.newImage("gfx/Enemies/EnmB_"..i.."_"..j..".png")
			enemyBGph[i][j]:setFilter("nearest","nearest")
			
			dat = enemyBGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			enemyBGph[i][j]:refresh()
		end
	
	end
	
	enemyCGph = lg.newImage("gfx/Enemies/EnmC.png")
	enemyCGph:setFilter("nearest","nearest")
	
	dat = enemyCGph:getData()
	dat:mapPixel( makeOpaquePink )
	enemyCGph:refresh()
	
	enmBrickGph = {}
	
	for i = 1,4,1 do
		enmBrickGph[i] = lg.newImage("gfx/Enemies/Brick_"..i..".png")
		enmBrickGph[i]:setFilter("nearest","nearest")
		
		dat = enmBrickGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmBrickGph[i]:refresh()
	end
	
	enmBrickBoxGph = lg.newImage("gfx/Enemies/Brick_Box.png")
	enmBrickBoxGph:setFilter("nearest","nearest")
	
	
	
	enmCoreGph = lg.newImage("gfx/Enemies/Core.png")
	enmCoreGph:setFilter("nearest","nearest")
		
	dat = enmCoreGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmCoreGph:refresh()
	
	
	
	enemyEGph = {}
	
	for i = 1,2,1 do
	
		enemyEGph[i] = {}
		
		for j = 1,4,1 do
			enemyEGph[i][j] = lg.newImage("gfx/Enemies/EnmE_"..i.."_"..j..".png")
			enemyEGph[i][j]:setFilter("nearest","nearest")
			
			dat = enemyEGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			enemyEGph[i][j]:refresh()
		end
	
	end
	
	enemyEBoxGph = lg.newImage("gfx/Enemies/EnmEBox.png")
	enemyEBoxGph:setFilter("nearest","nearest")
	
	
	
	enmExplodeAGph = {}
	
	for i = 1,4,1 do
		enmExplodeAGph[i] = lg.newImage("gfx/Enemies/ExplodeA_"..i..".png")
		enmExplodeAGph[i]:setFilter("nearest","nearest")
		
		dat = enmExplodeAGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplodeAGph[i]:refresh()
	
	end
	
	enmExplodeCGph = {}
	
	for i = 1,4,1 do
		enmExplodeCGph[i] = lg.newImage("gfx/Enemies/ExplodeC_"..i..".png")
		enmExplodeCGph[i]:setFilter("nearest","nearest")
		
		dat = enmExplodeCGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplodeCGph[i]:refresh()
	
	end
	
	enmShotGph = {}
	enmShotGph[1] = {}
	enmShotGph[3] = {}

	for i=1,2,1 do --only 1 shotframe in this game
		enmShotGph[1][i] = lg.newImage("gfx/Enemies/EnmShot_1_"..i..".png")
		enmShotGph[1][i]:setFilter("nearest","nearest")
			
		dat = enmShotGph[1][i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmShotGph[1][i]:refresh()
	end
	
	enmShotGph[2] = lg.newImage("gfx/Enemies/EnmShot_2.png")
	enmShotGph[2]:setFilter("nearest","nearest")
	
	dat = enmShotGph[2]:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotGph[2]:refresh()
	
	for i=1,4,1 do --only 1 shotframe in this game
		enmShotGph[3][i] = lg.newImage("gfx/Enemies/EnmShot_3_"..i..".png")
		enmShotGph[3][i]:setFilter("nearest","nearest")
			
		dat = enmShotGph[3][i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmShotGph[3][i]:refresh()
	end
	
	


end

function loadLevelGphs()

	levelGphs = {}

	for i=1,32,1 do
		levelGphs[i] = lg.newImage("gfx/Levels/Level_"..i..".png")
		levelGphs[i]:setFilter("nearest","nearest")
	end

end

function loadProjectileSprites()
	
end


function loadMiscSprites()


end

function loadSymbols()

	digitGph={}
	
	for i=1,10,1 do
		local dNum = i-1
		digitGph[i]= lg.newImage("gfx/Symbol/D_".. dNum ..".png")
		digitGph[i]:setFilter("nearest","nearest")
		
		dat = digitGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		digitGph[i]:refresh()
	end
	
	lvSymbolGph = lg.newImage("gfx/Symbol/L.png")
	lvSymbolGph:setFilter("nearest","nearest")
	dat = lvSymbolGph:getData()
	dat:mapPixel( makeOpaquePink )
	lvSymbolGph:refresh()
	
	extraSymbolGph = {}
	for i=1,1,1 do --only 1 player
	
		extraSymbolGph[i] = lg.newImage("gfx/Symbol/Extra_"..i..".png")
		extraSymbolGph[i]:setFilter("nearest","nearest")
		dat = extraSymbolGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		extraSymbolGph[i]:refresh()
	end
	
	infSymbolGph = lg.newImage("gfx/Symbol/Infinity.png")
	infSymbolGph:setFilter("nearest","nearest")
	dat = infSymbolGph:getData()
	dat:mapPixel( makeOpaquePink )
	infSymbolGph:refresh()

end

function loadOverlays()

	gameLogoGph = {}
	
	for i = 1,3,1 do
		gameLogoGph[i] = lg.newImage("gfx/Overlay/GameLogo_"..i..".png")
		gameLogoGph[i]:setFilter("nearest","nearest")
		
		dat = gameLogoGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		gameLogoGph[i]:refresh()
	end

	pauseGph = lg.newImage("gfx/Overlay/Pause.png")
	pauseGph:setFilter("nearest","nearest")
	dat = pauseGph:getData()
	dat:mapPixel( makeOpaquePink )
	pauseGph:refresh()
	
	gameOverOverlayGph = lg.newImage("gfx/Overlay/GameOver.png")
	gameOverOverlayGph:setFilter("nearest","nearest")
	dat = gameOverOverlayGph:getData()
	dat:mapPixel( makeOpaquePink )
	gameOverOverlayGph:refresh()
	
end

																										--Task AAH (part 2) load sound

function loadMp3()

end


function loadSfx()

	shot1Snd                = love.audio.newSource("sfx/Shot.wav", "static") 
	shot2Snd                = love.audio.newSource("sfx/Shot.wav", "static") 
	shot3Snd                = love.audio.newSource("sfx/Shot.wav", "static") 
	shipShotSnd             = love.audio.newSource("sfx/ShipShot.wav", "static")
	pumpShotSnd             = love.audio.newSource("sfx/Pumpshot.wav", "static") 
	playerExplosionSnd      = love.audio.newSource("sfx/PlayerExplosion.wav", "static")
	extraLifeSnd            = love.audio.newSource("sfx/ExtraLife.wav", "static")
	pauseSnd                = love.audio.newSource("sfx/Pause.wav", "static")
	enemyHitSnd             = love.audio.newSource("sfx/EnemyHit.wav", "static")
	enemyHit2Snd            = love.audio.newSource("sfx/EnemyHit2.wav", "static")
	enemyDie1Snd            = love.audio.newSource("sfx/EnemyDie1.wav", "static")
	enemyDie2Snd            = love.audio.newSource("sfx/EnemyDie2.wav", "static")
	enemyDie3Snd            = love.audio.newSource("sfx/EnemyDie3.wav", "static")
	enemyDie4Snd            = love.audio.newSource("sfx/EnemyDie4.wav", "static")
	
	shot1Snd:setVolume(0.4*0.6)
	shot2Snd:setVolume(0.4*0.6)
	shot3Snd:setVolume(0.4*0.6)
	shipShotSnd:setVolume(0.6)
	pumpShotSnd:setVolume(0.5)
	playerExplosionSnd:setVolume(0.8*0.6)
	extraLifeSnd:setVolume(0.6)
	pauseSnd:setVolume(1.0)
	enemyHitSnd:setVolume(1.0)
	enemyHit2Snd:setVolume(0.65)
	enemyDie1Snd:setVolume(0.4)
	enemyDie2Snd:setVolume(0.7)
	enemyDie3Snd:setVolume(0.6)
	enemyDie4Snd:setVolume(0.8)
	
	shotSnd = ShotSoundPool()
	
	
end
