require "luas.shortcuts"
require "luas.playerShip"
require "luas.playerBullet"
require "luas.enemyA"
require "luas.enemyB"
require "luas.enemyC"
require "luas.enemyD"
require "luas.enemyE"
require "luas.explosionA"
require "luas.explosionB"
require "luas.explosionC"
require "luas.playerExplosion"
require "luas.maskPrinter"
require "luas.levelSettings"
require "luas.enmBullet1"
require "luas.enmBullet2"
require "luas.enmBullet3"

function globInit()																			--Task AAL (part 2) init globals
	
	--define globals, called only once
	globScore = 0
	globMaxScore = 9999999
	
	globMaxPlayers = 1 -- only 1 player
	
	globMaxEnemyA = 150
	globMaxEnemyB = 200
	globMaxEnemyC = 10
	globMaxEnemyD = 10
	globMaxEnemyE = 10
	
	globLevel = 1
	globSubLevel = 1
	
	globLevelSettings = LevelSettings()

	--input mapping constants
	GLOB_INPUT_WAITING  = 0
	GLOB_INPUT_KEYBOARD = 1
	GLOB_INPUT_GAMEPAD  = 2
	GLOB_INPUT_MOUSE    = 3
	GLOB_INPUT_COMPUTER = 4 
	GLOB_INPUT_GAMEPAD2 = 5
	GLOB_INPUT_GAMEPAD3 = 6
	
	--input variables
	globInputType = {}
	
	for i = 1,globMaxPlayers,1 do
		globInputType[i] = GLOB_INPUT_WAITING --empty input
	end
	--to switch input for player i to keyboard, mouse or gamepad do something like
	--globInputType[i] = GLOB_INPUT_KEYBOARD
	
	globNumLifes={} --prepare for up to two players
	--set initial number of lifes.
	--encoding: 
	--## (-2) : player hasnt entered game
	--## (-1) : player has no lifes/game over for that particular player
	--## 0    : player's last life
	--## n    : player's current life + n lifes available
	globNumLifes[1]=2	--## player 1 starts with 3 lifes (current + 2 extra)
	--globNumLifes[2]=(-2) --only 1 player
	--globNumLifes[3]=(-2) --only 1 player
	
	--globally accessable
	globPlayerStartPosX = 94  
	globPlayerStartPosY = 114
	
	globPlayerLeftBounds = 0
	globPlayerRightBounds = 187
	
	
	--level clear countdown
	globLevelClearCountDownIndex    = 0 
	--globLevelClearCountDown         = 0
	globLevelClearCountDownMax      = 50
	globLevelClearCountDownResumePt = 1
	
	
	--Demo mute countdown (on entering or re-entering DemoMode or GameMode, block fire-key-input for
	--short time so there is no accidential game-restart and no awkward initial fire trigger
	globEntryMuteCountDownIndex    = 0 
	--globEntryMuteCountDown         = 0
	globEntryMuteCountDownMax      = 40
	globEntryMuteCountDownResumePt = 1
	
	
	--TODO register joystick not just at beginning of the game but check repeatedly. for now: 
	globJoystickMul = love.joystick.getJoysticks()
	globJoystick    = globJoystickMul[1] --TODO cannot use multiple joysticks this way
	globJoystick2   = globJoystickMul[2]
	globJoystick3   = globJoystickMul[3]
	
	--explosion containers will never need to be re-filled with new instances. set them up just once.
	globExplosionAIndex = 1
	globExplosionAMax   = 10
	globExplosionA = {}
	for i=1,globExplosionAMax,1 do
		globExplosionA[i] = ExplosionA()
	end
	
	globExplosionBIndex = 1
	globExplosionBMax   = 10
	globExplosionB = {}
	for i=1,globExplosionBMax,1 do
		globExplosionB[i] = ExplosionB()
	end
	
	globExplosionCIndex = 1
	globExplosionCMax   = 10
	globExplosionC = {}
	for i=1,globExplosionCMax,1 do
		globExplosionC[i] = ExplosionC()
	end
	
	globPlayerExplosionIndex = 1
	globPlayerExplosionMax   = 1--only 1 player, need only 1 explosion at a time
	globPlayerExplosions = {}
	for i=1,globPlayerExplosionMax,1 do
		globPlayerExplosions[i] = PlayerExplosion()
	end
	
	--mask printer will never be replaced, needs to carry info about last score and level over to demo display
	--even when the actual values that work in the game have already been reset
	globMaskPrinter = MaskPrinter()
	
	globNumEnemiesSwirling = 0
	
	--to manage the sounds it needs to be known everywhere whether the game is running in demoMode or gameMode
	globIsInDemoMode = false
	
	
	--colors for recoloring enemy CLASS
	globEnmCMainColorR = {}
	globEnmCMainColorG = {}
	globEnmCMainColorB = {}
	--
	globEnmCSubColorR = {}
	globEnmCSubColorG = {}
	globEnmCSubColorB = {}
	
	globEnmCMainColorR[1] = 40
	globEnmCMainColorG[1] = 40
	globEnmCMainColorB[1] = 231
	
	globEnmCMainColorR[2] = 15
	globEnmCMainColorG[2] = 139
	globEnmCMainColorB[2] = 11
	
	globEnmCMainColorR[3] = 153
	globEnmCMainColorG[3] = 79
	globEnmCMainColorB[3] = 183
	
	globEnmCMainColorR[4] = 203
	globEnmCMainColorG[4] = 0
	globEnmCMainColorB[4] = 0
	
	globEnmCSubColorR[1] = 240
	globEnmCSubColorG[1] = 0
	globEnmCSubColorB[1] = 240
	
	globEnmCSubColorR[2] = 207
	globEnmCSubColorG[2] = 179
	globEnmCSubColorB[2] = 7
	
	globEnmCSubColorR[3] = 0
	globEnmCSubColorG[3] = 203
	globEnmCSubColorB[3] = 203
	
	globEnmCSubColorR[4] = 151
	globEnmCSubColorG[4] = 151
	globEnmCSubColorB[4] = 151
	
	globEnmCMainColorIndex    = 1 --default
	globEnmCMainColorIndexMax = 4
	globEnmCSubColorIndex     = 1 --default
	globEnmCSubColorIndexMax  = 4
	
	globEnmDDeathColorR = {}
	globEnmDDeathColorG = {}
	globEnmDDeathColorB = {}
	
	globEnmDDeathColorR[1] = 40
	globEnmDDeathColorG[1] = 40
	globEnmDDeathColorB[1] = 231
	
	globEnmDDeathColorR[2] = 15
	globEnmDDeathColorG[2] = 139
	globEnmDDeathColorB[2] = 11
	
	globEnmDDeathColorR[3] = 153
	globEnmDDeathColorG[3] = 79
	globEnmDDeathColorB[3] = 183
	
	globEnmDDeathColorR[4] = 203
	globEnmDDeathColorG[4] = 0
	globEnmDDeathColorB[4] = 0
	
	globEnmDDeathColorR[5] = 240
	globEnmDDeathColorG[5] = 0
	globEnmDDeathColorB[5] = 240
	
	globEnmDDeathColorR[6] = 207
	globEnmDDeathColorG[6] = 179
	globEnmDDeathColorB[6] = 7
	
	globEnmDDeathColorR[7] = 0
	globEnmDDeathColorG[7] = 203
	globEnmDDeathColorB[7] = 203
	
	globEnmDDeathColorR[8] = 151
	globEnmDDeathColorG[8] = 151
	globEnmDDeathColorB[8] = 151
	
	globEnmDDeathColorIndex    = 1 --default
	globEnmDDeathColorIndexMax = 8
	
	
	globGroundColorR = {}
	globGroundColorG = {}
	globGroundColorB = {}
	
	globGroundColorR[1] = 43
	globGroundColorG[1] = 83
	globGroundColorB[1] = 151
	
	globGroundColorR[2] = 0
	globGroundColorG[2] = 83
	globGroundColorB[2] = 83
	
	globGroundColorR[3] = 139
	globGroundColorG[3] = 63
	globGroundColorB[3] = 43
	
	globGroundColorR[4] = 155
	globGroundColorG[4] = 65
	globGroundColorB[4] = 115
	
	globGroundColorR[5] = 176
	globGroundColorG[5] = 87
	globGroundColorB[5] = 27
	
	globGroundColorR[6] = 99
	globGroundColorG[6] = 99
	globGroundColorB[6] = 99
	
	globGroundColorR[7] = 179
	globGroundColorG[7] = 42
	globGroundColorB[7] = 35
	
	globGroundColorR[8] = 93
	globGroundColorG[8] = 71
	globGroundColorB[8] = 147
	
	globGroundColorR[9] = 59
	globGroundColorG[9] = 119
	globGroundColorB[9] = 39
	
	globGroundColorIndex = 1
	globGroundColorIndexMax = 9
	
	
end

function globResetGame()																--Task AAS (part 1) call globals reset for game mode

	globIsInDemoMode = false

	--on entering game, one device has been set and it is needed, so don't reset them.
	--for i = 1,globMaxPlayers,1 do
	--	globInputType[i] = GLOB_INPUT_WAITING 
	--end
	
	globLevel = 0 --with gameMode, keep restarting at level 1
	globSubLevel = 1

	globScore = 0 --on switch to new game, reset score
	
	--see max players
	globNumLifes[1]=3	--reset number of lifes
	--globNumLifes[2]=(-2) --only 1 player
	--globNumLifes[3]=(-2) --only 1 player

	

	globResetBasics()
	
	--#fetch input by which demo-mode was left
	--########################################
	
	globInputType[1] = gStateDemo.leaveStateWithDevice
	print("Globals: leaving demo-Mode with input-Type: "..globInputType[1])
	
	--# make first playership enter game using the selected input device
	--##################################################################
	globPlShip[1].enterGame(globPlShip[1],globInputType[1])
	
	--reset after demomode used it psychedelically
	globGroundColorIndex = 1

end


function globResetDemo()																--Task AAP (part 2) globals reset for demo

	globIsInDemoMode = true

	
	globLevel = 0
	globSubLevel = 1

	--globScore = 0 --on switch to demo, carry last score over
	
	--on switch to demo, reset all input modes to wait for input from player 
	--and determine input device for the next game round. Demomode MUST carry the
	--leaveStateDevice about the input key that caused it to terminate so the inputtype
	--can be initialized for first player. Gamemode must then react to and set the inputs
	--for other players.
	for i = 1,globMaxPlayers,1 do
		globInputType[i] = GLOB_INPUT_WAITING --empty input
		
		globNumLifes[i]=(-2) --number of lifes not defined for demo, demo can't go game over
	end
	globNumLifes[1] = 3 --need globNumLifes > 0 or else ship will deactivate itself in demomode

	globResetBasics()
	
	--demo needs playership too
	--TODO have enterGame() accept parameter for device, like
	--enterGame(globPlShip[1],GLOB_INPUT_WAITING)
	globInputType[1] = GLOB_INPUT_COMPUTER
	globPlShip[1].enterGame(globPlShip[1], globInputType[1])
	
end


function globResetBasics()


	-- do for both demoMode and gameMode resets
	
	--rebuild playership structures
	globPlShip ={}
	for i = 1,globMaxPlayers,1 do
		globPlShip[i] = PlayerShip()
		globPlShip[i].defineColorType(globPlShip[i],i) --different players need different shipcolors
	end
	
	--rebuild bullet container structure for playerbullet
	globLeadPlBullets     = {} --no multiple bullet types in this game, only lead bullets
	globLeadPlBulletIndex = {} --bullet index per player, hence use table
	globLeadPlBulletIndexMax  = 4 --reserve 4 bullets per player. 
	                       --to see how many are allowed to be actually used,SEE PLAYER CLASS
	
	--reload conditions reside in playerShip
	
	for i = 1,globMaxPlayers,1 do
	
		globLeadPlBullets[i]={}
		globLeadPlBulletIndex[i] = 1 --for each player, start with reference to 1st bullet in container 
	
		for j=1,globLeadPlBulletIndexMax,1 do
			--create 1 bullet per player and bulletslot
			globLeadPlBullets[i][j]  = PlayerBullet()
			
			--different players need different bulletColors
			globLeadPlBullets[i][j].defineColorType(globLeadPlBullets[i][j], i)
		end
	end
	
	--rebuild bullet container structure for enemybullets (does not affect leveltransition but gamestate transition)
	globEnmBullets1 = {}
	globEnmBullets1Index    = 1
	globEnmBullets1IndexMax = 150
	--
	for i= 1,globEnmBullets1IndexMax,1 do
		globEnmBullets1[i] = EnmBullet1()
	end
	
	globEnmBullets2 = {}
	globEnmBullets2Index    = 1
	globEnmBullets2IndexMax = 150
	--
	for i= 1,globEnmBullets2IndexMax,1 do
		globEnmBullets2[i] = EnmBullet2()
	end
	
	globEnmBullets3 = {}
	globEnmBullets3Index    = 1
	globEnmBullets3IndexMax = 150
	--
	for i= 1,globEnmBullets3IndexMax,1 do
		globEnmBullets3[i] = EnmBullet3()
	end
	

	--enemy rebuild enemy container structure, also needs to be done on each new level. so:
	globResetLevel()
	
end

function globResetLevel()
	--throw old enemies away, create new inactive ones that are at idle
	globEnemyA={}
	for i = 1,globMaxEnemyA,1 do
		globEnemyA[i] = EnemyA() 
	end
	
	globEnemyB={}
	for i = 1,globMaxEnemyB,1 do
		globEnemyB[i] = EnemyB() 
	end
	
	globEnemyC={}
	for i = 1,globMaxEnemyC,1 do
		globEnemyC[i] = EnemyC() 
	end
	
	globEnemyD={}
	for i = 1,globMaxEnemyD,1 do
		globEnemyD[i] = EnemyD() 
	end
	
	globEnemyE={}
	globEnemyEIndex = 1
	for i = 1,globMaxEnemyE,1 do
		globEnemyE[i] = EnemyE() 
	end
	
	--also need to deactivate explosions or else explosion animations will carry over from demo mode to game mode
	
	for i=1,globExplosionAMax,1 do
		globExplosionA[i].deactivate(globExplosionA[i])
	end
	
	for i=1,globExplosionBMax,1 do
		globExplosionB[i].deactivate(globExplosionB[i])
	end
	
	for i=1,globExplosionCMax,1 do
		globExplosionC[i].deactivate(globExplosionC[i])
	end
	
	for i=1,globPlayerExplosionMax,1 do
		globPlayerExplosions[i].deactivate(globPlayerExplosions[i])
	end

end

function globFillLevel()

	--point to first enemy
	globEnemyNextActivationIndex = 1
	
	local lclTotalLevel = globLevel*4 + globSubLevel

	print("Loading level "..lclTotalLevel)
	
	-- analyze current level
	local imgdat = levelGphs[lclTotalLevel]:getData()
	local fieldW = imgdat:getWidth()
	local fieldH = imgdat:getHeight()

	if globSubLevel == 1 then
		for j = 1,fieldH, 1 do --TODO need to look where row and col are needed and why index is off
			for i = 1,fieldW, 1 do
			
				local r, g, b, a =  imgdat:getPixel(i-1, j-1)
				local skip = false
				if r==255 and g==255 and b==254 then
					skip = true
				end
			
				if skip == false then --cell has relevant entry
				
					if r==0 and g == 140 and b == 0 then 
					
						local lclIndx = globEnemyNextActivationIndex
						globEnemyA[lclIndx].putStartPosition(globEnemyA[lclIndx], 10*(i-1), 10*(j-1))
						globEnemyA[lclIndx].activate(globEnemyA[lclIndx])
						globEnemyNextActivationIndex = globEnemyNextActivationIndex + 1
					end
				end
				
			end
		end
	end
	
	if globSubLevel == 2 then
	

	
		for j = 1,fieldH, 1 do --TODO need to look where row and col are needed and why index is off
			for i = 1,fieldW, 1 do
		
			
				local r, g, b, a =  imgdat:getPixel(i-1, j-1)
				local skip = false
				if r==255 and g==255 and b==254 then
					skip = true
				end
			
				if skip == false then --cell has relevant entry
					
					--########################################
					-- determine enemy according to pixelcolor
					--########################################
				
		
					if r==231 and g == 0 and b == 0 then 
				
						local lclIndx = globEnemyNextActivationIndex
						globEnemyB[lclIndx].putStartPosition(globEnemyB[lclIndx], i-1, j-1)
						globEnemyB[lclIndx].activate(globEnemyB[lclIndx], 1)
						globEnemyNextActivationIndex = globEnemyNextActivationIndex + 1
						
					elseif r==71 and g == 71 and b == 150 then 
					
						local lclIndx = globEnemyNextActivationIndex
						globEnemyB[lclIndx].putStartPosition(globEnemyB[lclIndx], i-1, j-1)
						globEnemyB[lclIndx].activate(globEnemyB[lclIndx], 2)
						globEnemyNextActivationIndex = globEnemyNextActivationIndex + 1
					
					end
					
				end
			
			end
		end
		
		
		
	end
	
	
	
	if globSubLevel == 3 then
		
		for j = 1,fieldH, 1 do --TODO need to look where row and col are needed and why index is off
			for i = 1,fieldW, 1 do
		
			
				local r, g, b, a =  imgdat:getPixel(i-1, j-1)
				local skip = false
				if r==255 and g==255 and b==254 then
					skip = true
				end
				if r==103 and g==163 and b==83 then
					skip = true
				end
			
				if skip == false then --cell has relevant entry
				
					if r==83 and g == 83 and b == 83 then 
					
						local lclIndx = globEnemyNextActivationIndex
						globEnemyC[lclIndx].putStartPosition(globEnemyC[lclIndx], i-1, j-1)
						globEnemyC[lclIndx].activate(globEnemyC[lclIndx])
						globEnemyNextActivationIndex = globEnemyNextActivationIndex + 1
					
					end
		
		
				end
				
			end
		end
		
	end
	
	
	
	if globSubLevel == 4 then
		
		for j = 1,fieldH, 1 do --TODO need to look where row and col are needed and why index is off
			for i = 1,fieldW, 1 do
		
			
				local r, g, b, a =  imgdat:getPixel(i-1, j-1)
				local skip = false
				if r==255 and g==255 and b==254 then
					skip = true
				end
				if r==103 and g==163 and b==83 then
					skip = true
				end
			
				if skip == false then --cell has relevant entry
				
					if r==151 and g == 151 and b == 151 then 
					
						local lclIndx = globEnemyNextActivationIndex
						globEnemyD[lclIndx].putStartPosition(globEnemyD[lclIndx], i-1, j-1)
						globEnemyD[lclIndx].activate(globEnemyD[lclIndx])
						globEnemyNextActivationIndex = globEnemyNextActivationIndex + 1
						
					end
				
				end
			end
		end
	end
	
	

end


function globAddScore(aScorePlus)

	globScore = globScore + aScorePlus
	
	if globScore > globMaxScore then
		globScore = globMaxScore
	end
	--
	--extralife-relevant-score for player is only counted after joining (so different players may
	--gain lifes at different times, let playership handle when it will accept individual score addition)
	for i = 1,globMaxPlayers,1 do 
		if globPlShip[i] ~= nil then
			globPlShip[i].addScore(globPlShip[i], aScorePlus)
		end
	end
	
end


