require "luas.shortcuts"

MaskPrinter = Object:extend()

function MaskPrinter.new(self)

	self.setConsts(self)

	--changeables, set with doUpdate, with values from globals
	--
	self.mode                = MASK_PRINT_DEMOMODE --gameMode, demoMode
	--self.gameOver            = false
	
	self.numLevel            = 1
	
	self.numPlayerLifes      = {}
	self.numPlayerLifes[1]   = 0
	--self.numPlayerLifes[2]   = 0
	--self.numPlayerLifes[3]   = 0
	
	self.valScore            = 0
	
	--self.demoTimer = 0     --may want to display certain details only as time progresses
	--self.demoTMax  = 10000 --need to always reset it on gameMode and count it up on demoMode
					         --unless it has its maximum value (possibly reloop a part of it)
end

function MaskPrinter.setConsts(self)


	--constants
	MASK_LINE_SCORE_Y  = 127 - 1
	MASK_LINE_LIFES_Y  = MASK_LINE_SCORE_Y
	--MASK_LINE_LIFES_1ST_Y = 131 - 1
	--MASK_LINE_LIFES_2ND_3RD_Y = 141 - 1 --absolute positions always need a subtraction of -1 to get to the
	--level symbol                      --pixelpos that were counted. this is because coordinates start with 0
	MASK_LV_SYM_X    = 0
	MASK_LV_SYM_Y    = MASK_LINE_SCORE_Y


	MASK_OFFSET_DIGITSYMBOL = 10 --1 pixel fallacy does not apply to distances
	MASK_OFFSET_SHIPSYMBOL  = 16


	MASK_LV_DIGIT_PX  = {}
	MASK_LV_DIGIT_PY  = {}
	--
	MASK_LV_DIGIT_PX[1] = 38 - 1
	MASK_LV_DIGIT_PX[2] = MASK_LV_DIGIT_PX[1] - MASK_OFFSET_DIGITSYMBOL
	MASK_LV_DIGIT_PY[1] = MASK_LINE_SCORE_Y
	MASK_LV_DIGIT_PY[2] = MASK_LINE_SCORE_Y


	--positions for extra-life symbols
	MASK_PL_SHIP_PX = {}
	MASK_PL_SHIP_PY = {}
	--
	MASK_PL_SHIP_PX[1] = {} --Xs for players 1-3
	--MASK_PL_SHIP_PX[2] = {}
	--MASK_PL_SHIP_PX[3] = {}
	--
	MASK_PL_SHIP_PY[1] = {} --Ys for players 1-3
	--MASK_PL_SHIP_PY[2] = {}
	--MASK_PL_SHIP_PY[3] = {}
	--
	--Player1 Shipsymbols
	MASK_PL_SHIP_PX[1][1] = 69 - 1
	MASK_PL_SHIP_PX[1][2] = MASK_PL_SHIP_PX[1][1] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[1][3] = MASK_PL_SHIP_PX[1][2] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[1][4] = MASK_PL_SHIP_PX[1][3] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[1][5] = MASK_PL_SHIP_PX[1][1] - MASK_OFFSET_SHIPSYMBOL --hang the 5th extralife on the left side
	--
	MASK_PL_SHIP_PY[1][1] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[1][2] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[1][3] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[1][4] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[1][5] = MASK_LINE_LIFES_Y
	--
	--

	--positions for scoredigits
	MASK_SCORE_DIGIT_PX = {}
	MASK_SCORE_DIGIT_PY = {}
	--
	MASK_SCORE_DIGIT_PX[1] = 189 - 1
	MASK_SCORE_DIGIT_PX[2] = MASK_SCORE_DIGIT_PX[1] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[3] = MASK_SCORE_DIGIT_PX[2] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[4] = MASK_SCORE_DIGIT_PX[3] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[5] = MASK_SCORE_DIGIT_PX[4] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[6] = MASK_SCORE_DIGIT_PX[5] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[7] = MASK_SCORE_DIGIT_PX[6] - MASK_OFFSET_DIGITSYMBOL
	--
	MASK_SCORE_DIGIT_PY[1] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[2] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[3] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[4] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[5] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[6] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[7] = MASK_LINE_SCORE_Y

	MASK_PRINT_DEMOMODE = 1
	MASK_PRINT_GAMEMODE = 2

	MASK_PRINT_MAX_LEVEL = 20 	

end

function MaskPrinter.doUpdate(self, aDemoFlag)

	if aDemoFlag == true then
		self.mode = MASK_PRINT_DEMOMODE
	else
		self.mode = MASK_PRINT_GAMEMODE
	end
	
	if self.mode == MASK_PRINT_GAMEMODE then
	
		--for game mode
		self.numLevel            = globLevel*4 + globSubLevel
		for i= 1,1,1 do
			self.numPlayerLifes[i]   = globNumLifes[i]
			
			if self.numPlayerLifes[i] < 0 then --globals define negative values for lifes (gameover =(-1),not joined = (-2))
				self.numPlayerLifes[i] = 0     --for printing ignore those and treat like 0 lifes to print
			end
		end
		self.valScore            = globScore
		
		--self.demoTimer = 0
	
	
	elseif self.mode == MASK_PRINT_DEMOMODE then
		--for demo mode
		
		--keep the last score (don't actualize), if game was never started score is 0 by constructor declaration
		
		--print no lifes (reset, don't fetch current values)
		self.numPlayerLifes[1]   = 3
		
		--TODO print title, producerlogo and press fire to start instead of lifes
		
		--keep levelnumber of last level that was reached, don't actualize.
		--if game was never started this will give 00 as level
		
		--if self.demoTimer < self.demoTMax then
		--  self.demoTimer = self.demoTimer + 1   --possibly draw something with time progress
		--end
		
		
	end
end


function MaskPrinter.draw(self, aDemoFlag)

	
	self.printLSymbol(self)
	self.printLevelNumber(self)

	--if aDemoFlag == false then --in this game print lifes for demo also
	
		self.printExtraLives(self) --TODO restrict for demo
	--end

	self.printScore(self)
	
end


function MaskPrinter.printExtraLives(self)

	for i=1,1,1 do -- max 1 players
	
		
		for j=1,5,1 do -- max 5 lifes extra
		
			if self.numPlayerLifes[i] >= j then--player has that life that is to print next
			
				--take symbol directly from extendedloader
				lg.draw(extraSymbolGph[i], MASK_PL_SHIP_PX[i][j], MASK_PL_SHIP_PY[i][j], 0, 1, 1)
			end
		end
	end
end

function MaskPrinter.printLSymbol(self)

		lg.draw(lvSymbolGph, MASK_LV_SYM_X, MASK_LV_SYM_Y, 0, 1, 1)
end



function MaskPrinter.printLevelNumber(self)

	if self.numLevel > MASK_PRINT_MAX_LEVEL then
		
		--print infinity symbol at 2nd level digit position
		lg.draw(infSymbolGph, MASK_LV_DIGIT_PX[2], MASK_LV_DIGIT_PY[2], 0, 1, 1)
	else
					
		lDigit1= self.numLevel % 10				--single num
		lDigit2= (self.numLevel - lDigit1) / 10 --10s
			
		lg.draw(digitGph[lDigit1 + 1], MASK_LV_DIGIT_PX[1], MASK_LV_DIGIT_PY[1], 0, 1, 1)
		lg.draw(digitGph[lDigit2 + 1], MASK_LV_DIGIT_PX[2], MASK_LV_DIGIT_PY[2], 0, 1, 1)
		
	end
end


function MaskPrinter.printScore(self)

	--print score without leading zeros
	sDigit1= self.valScore % 10
	sDigit2= ((self.valScore - sDigit1) % 100) / 10
	sDigit3= ((self.valScore - sDigit2*10 - sDigit1) % 1000) / 100
	sDigit4= ((self.valScore - sDigit3*100 - sDigit2*10 - sDigit1) % 10000) / 1000 
	sDigit5= ((self.valScore - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) % 100000) / 10000
	sDigit6= ((self.valScore - sDigit5*10000 - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) % 1000000) / 100000 
	sDigit7= ((self.valScore - sDigit6*100000 - sDigit5*10000 - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) / 1000000)
		
		
	--always print first digit even when 0
	lg.draw(digitGph[sDigit1 + 1], MASK_SCORE_DIGIT_PX[1], MASK_SCORE_DIGIT_PY[1], 0, 1, 1)
		
	if self.valScore >= 10 then
		lg.draw(digitGph[sDigit2 + 1], MASK_SCORE_DIGIT_PX[2], MASK_SCORE_DIGIT_PY[2], 0, 1, 1)
	end
	if self.valScore >= 100 then
		lg.draw(digitGph[sDigit3 + 1], MASK_SCORE_DIGIT_PX[3], MASK_SCORE_DIGIT_PY[3], 0, 1, 1)
	end
	if self.valScore >= 1000 then
		lg.draw(digitGph[sDigit4 + 1], MASK_SCORE_DIGIT_PX[4], MASK_SCORE_DIGIT_PY[4], 0, 1, 1)
	end
	if self.valScore >= 10000 then
		lg.draw(digitGph[sDigit5 + 1], MASK_SCORE_DIGIT_PX[5], MASK_SCORE_DIGIT_PY[5], 0, 1, 1)
	end
	if self.valScore >= 100000 then
		lg.draw(digitGph[sDigit6 + 1], MASK_SCORE_DIGIT_PX[6], MASK_SCORE_DIGIT_PY[6], 0, 1, 1)
	end
	if self.valScore >= 1000000 then
		lg.draw(digitGph[sDigit7 + 1], MASK_SCORE_DIGIT_PX[7], MASK_SCORE_DIGIT_PY[7], 0, 1, 1)
	end
	
end

