
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

PlayerExplosion = Object:extend()

function PlayerExplosion.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.frames = {}
	
	--self.anmStep       = 17 --use for index of frame (here set invalid)
	--self.anmThresh     = 16
	
	self.anmStep       = 1 --use for index of frame (here set invalid)
	self.anmThresh     = 6
	self.anmIndex      = 1
	self.anmIndexMax   = 8
	
	self.explosionColor = 0 --invalid value

end

function PlayerExplosion.defineColorType(self, aColorNum) --multiplayer needs different shipcolors
	
	--define color
	self.explosionColor = aColorNum
 
end

function PlayerExplosion.activate(self, aPX, aPY)

	self.active = true

	self.x = aPX
	self.y = aPY
	
	self.anmStep = 1
	self.anmIndex= 1
	
	self.frames[1] = playerExplodeGph[self.explosionColor][1]
	self.frames[2] = playerExplodeGph[self.explosionColor][2]
	self.frames[3] = playerExplodeGph[self.explosionColor][3]
	self.frames[4] = playerExplodeGph[self.explosionColor][4]
	self.frames[5] = playerExplodeGph[self.explosionColor][5]
	self.frames[6] = playerExplodeGph[self.explosionColor][6]
	self.frames[7] = playerExplodeGph[self.explosionColor][7]
	self.frames[8] = playerExplodeGph[self.explosionColor][8]
	
end

function PlayerExplosion.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function PlayerExplosion.doUpdate(self)

	if self.active then
		if self.anmStep < self.anmThresh then
			self.anmStep = self.anmStep + 1
			
			if self.anmStep >= self.anmThresh then
			
				self.anmStep = 1
				self.anmIndex = self.anmIndex + 1
			end
		end
	
		if self.anmIndex > self.anmIndexMax then
			self.deactivate(self)
		end
	end
end

function PlayerExplosion.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmIndex], self.x, self.y, 0, 1, 1)
	end
end


